open Tk

open Support

let version = "$Id: frx_toplevel.ml,v 1.1 1995/09/29 16:42:05 rouaix Exp $"

let make_visible atom =
  if Winfo.exists atom then
    if not (Winfo.ismapped atom) then
      Wm.deiconify atom

let valid_component_path str =
  let res = String.create (String.length str) in
  let convertc = function
      'A' .. 'Z' as c -> Char.chr (Char.code c - 32)
    | 'a' .. 'z' as c -> c
    | '0' .. '9' as c -> c
    | '_' -> '_'
    | _ -> '#' in
  for i = 0 to String.length str - 1 do
    res.[i] <- convertc str.[i]
  done;
  str 




(* Toplevel numbering *)
(* Ceci va poser un probleme avec la table de memorisation des callbacks.
   new_toplevel_widget va toujours *enregistrer* le widget
*)

let new base options =
  (* remove problematic characters *)
  let truebase = valid_component_path base in
  (* loop through numbered windows *)
  let rec find_unused =
    let cnter = ref 1 in
    function () ->
        let w = Support.new_toplevel_widget 
      	  (truebase ^ "<" ^ string_of_int !cnter ^ ">") in
	if Winfo.exists w then begin
	   incr cnter;
	   find_unused()
	   end
	else w in
  (* create a toplevel widget *)
  let w = Support.new_toplevel_widget truebase in
    if Winfo.exists w then
      Toplevelw.create (find_unused ()) options
    else Toplevelw.create w options

(*********** Memo **********)
